#!/bin/sh
# $Id: remove.sh 649 2007-06-04 00:26:23Z henry $
# remove event script for mountmon
#
# See mountmon.conf for list of environment variables available on input
# and required output values
#

# Unmount forcibly - there's no way to be nice about it, since the device has
# already been removed... If the unmount succeeds, a umount event will be sent
RESULT=0
MESSAGE=
DBGOUT=/dev/null
[ "${DAEMON_LOGDIR}" != "" ] && DBGOUT=${DAEMON_LOGDIR}/remove.$$

SCRIPT_VER='$Rev: 649 $'
echo "# Starting $0 version ${SCRIPT_VER}"

# Get MMS_PUID and other useful stuff based on DEVPATH
. mountmon_utils.sh

# Invoke daemon scripts with provisional unload
SVC_LIST=$(service_list)
if [ "${SVC_LIST}" != "_no_services_found_" ]
then
	for svc in ${SVC_LIST}
	do
	  # Stop daemon iff it was loaded with the same devpath
	  service_control ${svc} unload ${DEVPATH} >>${DBGOUT} 2>&1
	done
fi

if [ "${MM_CURRENT_MOUNTPOINT}" != "" ]
then
  if [ "${MM_VERBOSE}" = "1" ]
  then
    set >/tmp/mountmon.remove.$$
  fi
  echo "# attempting unmount of ${MM_CURRENT_MOUNTPOINT}"
  echo "UMOUNT=${MM_CURRENT_MOUNTPOINT}"
  MESSAGE="Unmounting ${MM_CURRENT_MOUNTPOINT}: $(umount -f $MM_CURRENT_MOUNTPOINT)" || RESULT=1
fi

echo "RESULT=${RESULT}"
echo "MESSAGE=${MESSAGE}"

return 0

